org.jgroups.protocols

## Class Discovery

- java.lang.Object
- - org.jgroups.stack.Protocol
  - - org.jgroups.protocols.Discovery

- Direct Known Subclasses:
    FILE_PING, PING, TCPGOSSIP, TCPPING

      public abstract class Discovery
      extends Protocol

  The Discovery protocol layer retrieves the initial membership (used by the GMS when started by sending event FIND_INITIAL_MBRS down the stack). We do this by specific subclasses, e.g. by mcasting PING requests to an IP MCAST address or, if gossiping is enabled, by contacting the GossipRouter. The responses should allow us to determine the coordinator whom we have to contact, e.g. in case we want to join the group. When we are a server (after having received the BECOME_SERVER event), we'll respond to PING requests with a PING response.

  The FIND_INITIAL_MBRS event will eventually be answered with a FIND_INITIAL_MBRS_OK event up the stack. The following properties are available

  - timeout - the timeout (ms) to wait for the initial members, default is 3000=3 secs
  - num_initial_members - the minimum number of initial members for a FIND_INITAL_MBRS, default is 2
  - num_ping_requests - the number of GET_MBRS_REQ messages to be sent (min=1), distributed over timeout ms
  Author:
    Bela Ban

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `Discovery.Responses`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.lang.String` | `group_addr`
    `protected Address` | `local_addr`
    `protected java.util.Vector<Address>` | `members`
    `protected java.util.Set<Discovery.Responses>` | `ping_responses`
    `protected int` | `rank`
    `protected TimeScheduler` | `timer`
    `protected View` | `view`

    - ### Fields inherited from class org.jgroups.stack.Protocol

      `down_prot, ergonomics, id, log, name, stack, stats, up_prot`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Discovery()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `discoveryRequestReceived(Address sender, java.lang.String logical_name, java.util.Collection<PhysicalAddress> physical_addrs)`
    `java.lang.Object` | `down(Event evt)` An event is to be sent down the stack.
    `java.util.List<PingData>` | `findAllMembers(Promise<JoinRsp> promise)`
    `java.util.List<View>` | `findAllViews(Promise<JoinRsp> promise)` Finds the views: sends a GET_MBRS_REQ to all members, waits 'timeout' ms or until 'num_initial_members' have been retrieved
    `java.lang.String` | `findAllViewsAsString()`
    `java.util.List<PingData>` | `findInitialMembers(Promise<JoinRsp> promise)` Finds initial members
    `protected java.util.List<PingData>` | `findInitialMembers(Promise<JoinRsp> promise, int num_expected_rsps, boolean break_on_coord, boolean return_views_only)`
    `java.lang.String` | `findInitialMembersAsString()`
    `int` | `getNumberOfDiscoveryRequestsSent()`
    `int` | `getNumInitialMembers()`
    `int` | `getNumPingRequests()`
    `long` | `getTimeout()`
    `java.lang.String` | `getView()`
    `void` | `handleConnect()`
    `void` | `handleDisconnect()`
    `void` | `init()` Called after instance has been created (null constructor) and before protocol is started.
    `protected View` | `makeView(java.util.Vector<Address> mbrs)`
    `java.util.Vector<java.lang.Integer>` | `providedUpServices()` List of events that are provided to layers above (they will be handled when sent down from above).
    `void` | `resetStats()`
    `abstract void` | `sendGetMembersRequest(java.lang.String cluster_name, Promise promise, boolean return_views_only)`
    `void` | `setNumInitialMembers(int num_initial_members)`
    `void` | `setNumPingRequests(int num_ping_requests)`
    `void` | `setTimeout(long timeout)`
    `void` | `start()` This method is called on a `Channel.connect(String)`.
    `void` | `stop()` This method is called on a `Channel.disconnect()`.
    `java.lang.Object` | `up(Event evt)` An event was received from the layer below.

    - ### Methods inherited from class org.jgroups.stack.Protocol

      `destroy, downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, isErgonomics, printStats, providedDownServices, requiredDownServices, requiredUpServices, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, statsEnabled, upThreadEnabled`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### rank

          protected int rank

    - #### timer

          protected TimeScheduler timer

    - #### view

          protected View view

    - #### members

          protected final java.util.Vector<Address> members

    - #### local_addr

          protected Address local_addr

    - #### group_addr

          protected java.lang.String group_addr

    - #### ping_responses

          protected final java.util.Set<Discovery.Responses> ping_responses

  - ### Constructor Detail

    - #### Discovery

          public Discovery()

  - ### Method Detail

    - #### init

          public void init()
                    throws java.lang.Exception

      Description copied from class: `Protocol`
      Called after instance has been created (null constructor) and before protocol is started. Properties are already set. Other protocols are not yet connected and events cannot yet be sent.
      Overrides:
        `init` in class `Protocol`
      Throws:
        `java.lang.Exception` - Thrown if protocol cannot be initialized successfully. This will cause the ProtocolStack to fail, so the channel constructor will throw an exception

    - #### sendGetMembersRequest

          public abstract void sendGetMembersRequest(java.lang.String cluster_name,
                                   Promise promise,
                                   boolean return_views_only)
                                              throws java.lang.Exception

      Throws:
        `java.lang.Exception`

    - #### handleDisconnect

          public void handleDisconnect()

    - #### handleConnect

          public void handleConnect()

    - #### discoveryRequestReceived

          public void discoveryRequestReceived(Address sender,
                                      java.lang.String logical_name,
                                      java.util.Collection<PhysicalAddress> physical_addrs)

    - #### getTimeout

          public long getTimeout()

    - #### setTimeout

          public void setTimeout(long timeout)

    - #### getNumInitialMembers

          public int getNumInitialMembers()

    - #### setNumInitialMembers

          public void setNumInitialMembers(int num_initial_members)

    - #### getNumPingRequests

          public int getNumPingRequests()

    - #### setNumPingRequests

          public void setNumPingRequests(int num_ping_requests)

    - #### getNumberOfDiscoveryRequestsSent

          public int getNumberOfDiscoveryRequestsSent()

    - #### getView

          public java.lang.String getView()

    - #### providedUpServices

          public java.util.Vector<java.lang.Integer> providedUpServices()

      Description copied from class: `Protocol`
      List of events that are provided to layers above (they will be handled when sent down from above).
      Overrides:
        `providedUpServices` in class `Protocol`
      Returns:
        Vector (of Integers)

    - #### resetStats

          public void resetStats()

      Overrides:
        `resetStats` in class `Protocol`

    - #### start

          public void start()
                     throws java.lang.Exception

      Description copied from class: `Protocol`
      This method is called on a `Channel.connect(String)`. Starts work. Protocols are connected and queues are ready to receive events. Will be called from bottom to top. This call will replace the START and START_OK events.
      Overrides:
        `start` in class `Protocol`
      Throws:
        `java.lang.Exception` - Thrown if protocol cannot be started successfully. This will cause the ProtocolStack to fail, so `Channel.connect(String)` will throw an exception

    - #### stop

          public void stop()

      Description copied from class: `Protocol`
      This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed
      Overrides:
        `stop` in class `Protocol`

    - #### findAllViews

          public java.util.List<View> findAllViews(Promise<JoinRsp> promise)

      Finds the views: sends a GET_MBRS_REQ to all members, waits 'timeout' ms or until 'num_initial_members' have been retrieved
      Returns:
        List

    - #### findInitialMembers

          public java.util.List<PingData> findInitialMembers(Promise<JoinRsp> promise)

      Finds initial members
      Parameters:
        `promise` -
      Returns:

    - #### findAllMembers

          public java.util.List<PingData> findAllMembers(Promise<JoinRsp> promise)

    - #### findInitialMembers

          protected java.util.List<PingData> findInitialMembers(Promise<JoinRsp> promise,
                                                    int num_expected_rsps,
                                                    boolean break_on_coord,
                                                    boolean return_views_only)

    - #### findInitialMembersAsString

          public java.lang.String findInitialMembersAsString()

    - #### findAllViewsAsString

          public java.lang.String findAllViewsAsString()

    - #### up

          public java.lang.Object up(Event evt)

      An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `PassDown` or c) the event (or another event) is sent up the stack using `PassUp`.

      For the PING protocol, the Up operation does the following things. 1. If the event is a Event.MSG then PING will inspect the message header. If the header is null, PING simply passes up the event If the header is PingHeader.GET_MBRS_REQ then the PING protocol will PassDown a PingRequest message If the header is PingHeader.GET_MBRS_RSP we will add the message to the initial members vector and wake up any waiting threads. 2. If the event is Event.SET_LOCAL_ADDR we will simple set the local address of this protocol 3. For all other messages we simple pass it up to the protocol above
      Overrides:
        `up` in class `Protocol`
      Parameters:
        `evt` - - the event that has been sent from the layer below

    - #### down

          public java.lang.Object down(Event evt)

      An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `PassDown`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`. The PING protocol is interested in several different down events, Event.FIND_INITIAL_MBRS - sent by the GMS layer and expecting a GET_MBRS_OK Event.TMP_VIEW and Event.VIEW_CHANGE - a view change event Event.BECOME_SERVER - called after client has joined and is fully working group member Event.CONNECT, Event.DISCONNECT.
      Overrides:
        `down` in class `Protocol`

    - #### makeView

          protected final View makeView(java.util.Vector<Address> mbrs)

Copyright © 1998-2009 Bela Ban / Red Hat. All Rights Reserved.